// Solutions to the Advent Of Code 2024.
// Copyright (C) 2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <map>
#include <string>

#include <aoc/extra/KeypadPatternTransformation.hpp>
#include <aoc/common/Point2.hpp>

class KeypadRobot
{
public:
    KeypadRobot(const std::map<char, Point2>&& keypad, const Point2&& forbidden);
    KeypadPatternTransformation calcTransformation(const std::string& targetOutputKeys) const;
private:
    const std::map<char, Point2> keypad_;
    const Point2 forbidden_;
    void move(std::ostringstream& stream, const int delta, const char positive, const char negative,
        int& nDuplicates) const;
    bool isForbidden(const int x, const int y) const;
};
