// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024-2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <aoc/framework/LinesSolver.hpp>

template <typename T1, typename T2>
LinesSolver<T1, T2>::LinesSolver(const int inputFileNameSuffix)
    : Solver<T1, T2> { inputFileNameSuffix }
{
}

template <typename T1, typename T2>
void LinesSolver<T1, T2>::processDataLine(const std::string& line)
{
    lines.push_back(line);
}

template <typename T1, typename T2>
bool LinesSolver<T1, T2>::isInBounds(const Point2& point) const
{
    return lines.isInBounds(point);
}

template <typename T1, typename T2>
char LinesSolver<T1, T2>::getCharAt(const Point2& point) const
{
    return lines.getCharAt(point);
}

template <typename T1, typename T2>
void LinesSolver<T1, T2>::setCharAt(const Point2& point, const char value)
{
    lines.setCharAt(point, value);
}

template <typename T1, typename T2>
Point2 LinesSolver<T1, T2>::findChar(const char c) const
{
    return lines.findChar(c);
}
