// Solutions to the Advent Of Code 2024.
// Copyright (C) 2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#include <aoc/common/Math.hpp>

#include <array>

int Math::ipow(const int base, const int exponent)
{
    int result = 1;
    for (int i = 1; i <= exponent; i++)
    {
        result *= base;
    }
    return result;
}

std::tuple<int, int, int> Math::extendedEuclid(const int a, const int b)
{
    std::array<std::pair<int, int>, 3> rst{ { { a, b }, { 1, 0 }, { 0, 1 } } };
    int q;
    int r;

    while (rst[0].second > 0)
    {
        q = rst[0].first / rst[0].second;
        for (auto& p : rst)
        {
            r = p.first - q * p.second;
            p.first = p.second;
            p.second = r;
        }
    }
    return { rst[0].first, rst[1].first, rst[2].first };
}
